
!WAPackage class methodsFor: '*seaside-pharo-flow' stamp: 'jf 8/31/2009 14:29'!
seasidePharoFlow
	^ self new
		name: 'Seaside-Pharo-Flow';
		addDependency: 'Seaside-Flow';
		addDependency: 'Seaside-Pharo-Platform';
		addDependency: 'Seaside-Pharo-Continuation';
		yourself! !

!WASqueakPlatform methodsFor: '*seaside-pharo-flow' stamp: 'lr 3/5/2009 21:03'!
callbackMarker
	| context |
	context := thisContext sender.
	[ context isNil or: [ (context receiver isKindOf: WACallback) or: [ context method == (WATaskVisitor >> #visitTask:) ] ] ]
		whileFalse: [ context := context sender ].
	context isNil
		ifTrue: [ self error: 'You can only #call: and #answer: from within a callback or a Task.' ].
	^ context! !

!WASqueakPlatform methodsFor: '*seaside-pharo-flow' stamp: 'jf 2/13/2009 15:53'!
suspendFlowDo: aBlock
	| continuation |
	continuation := WAPartialContinuation
		from: thisContext sender
		to: self callbackMarker.
	^ aBlock value: [ :answer |
		[ continuation value: answer ]
			on: WAMarkerRequest
			do: [ :request | request resume: self callbackMarker ] ]! !
